var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { Fragment } from 'react';
import { SchemaField } from '@formily/react-schema-renderer';
import { toArr, isFn, FormPath } from '@formily/shared';
import { ArrayList } from '@formily/react-shared-components';
import { CircleButton } from '../circle-button';
import { TextButton } from '../text-button';
import { Card } from 'antd';
import { PlusOutlined, DeleteOutlined, DownOutlined, UpOutlined } from '@ant-design/icons';
import styled from 'styled-components';
import cls from 'classnames';
var ArrayComponents = {
    CircleButton: CircleButton,
    TextButton: TextButton,
    AdditionIcon: function () { return React.createElement(PlusOutlined, null); },
    RemoveIcon: function () { return React.createElement(DeleteOutlined, null); },
    MoveDownIcon: function () { return React.createElement(DownOutlined, null); },
    MoveUpIcon: function () { return React.createElement(UpOutlined, null); }
};
export var ArrayCards = styled(function (props) {
    var value = props.value, schema = props.schema, className = props.className, editable = props.editable, path = props.path, mutators = props.mutators;
    var _a = schema.getExtendsComponentProps() || {}, renderAddition = _a.renderAddition, renderRemove = _a.renderRemove, renderMoveDown = _a.renderMoveDown, renderMoveUp = _a.renderMoveUp, renderEmpty = _a.renderEmpty, renderExtraOperations = _a.renderExtraOperations, componentProps = __rest(_a, ["renderAddition", "renderRemove", "renderMoveDown", "renderMoveUp", "renderEmpty", "renderExtraOperations"]);
    var schemaItems = Array.isArray(schema.items)
        ? schema.items[schema.items.length - 1]
        : schema.items;
    var onAdd = function () {
        if (schemaItems) {
            mutators.push(schemaItems.getEmptyValue());
        }
    };
    return (React.createElement("div", { className: className },
        React.createElement(ArrayList, { value: value, minItems: schema.minItems, maxItems: schema.maxItems, editable: editable, components: ArrayComponents, renders: {
                renderAddition: renderAddition,
                renderRemove: renderRemove,
                renderMoveDown: renderMoveDown,
                renderMoveUp: renderMoveUp,
                renderEmpty: renderEmpty
            } },
            toArr(value).map(function (item, index) {
                return (React.createElement(Card, __assign({}, componentProps, { size: "small", className: cls("card-list-item", componentProps.className), key: index, title: React.createElement("span", null,
                        index + 1,
                        React.createElement("span", null, "."),
                        " ",
                        componentProps.title || schema.title), extra: React.createElement(Fragment, null,
                        React.createElement(ArrayList.Remove, { index: index, onClick: function () { return mutators.remove(index); } }),
                        React.createElement(ArrayList.MoveDown, { index: index, onClick: function () { return mutators.moveDown(index); } }),
                        React.createElement(ArrayList.MoveUp, { index: index, onClick: function () { return mutators.moveUp(index); } }),
                        isFn(renderExtraOperations)
                            ? renderExtraOperations(index)
                            : renderExtraOperations) }), schemaItems && (React.createElement(SchemaField, { path: FormPath.parse(path).concat(index), schema: schemaItems }))));
            }),
            React.createElement(ArrayList.Empty, null, function (_a) {
                var children = _a.children, allowAddition = _a.allowAddition;
                return (React.createElement(Card, __assign({}, componentProps, { size: "small", className: "card-list-item card-list-empty " + (allowAddition ? 'add-pointer' : ''), onClick: allowAddition ? onAdd : undefined }),
                    React.createElement("div", { className: "empty-wrapper" }, children)));
            }),
            React.createElement(ArrayList.Addition, null, function (_a) {
                var children = _a.children, isEmpty = _a.isEmpty;
                if (!isEmpty) {
                    return (React.createElement("div", { className: "array-cards-addition", onClick: onAdd }, children));
                }
            }))));
})(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 100%;\n  .ant-card {\n    .ant-card {\n      box-shadow: none;\n    }\n    .ant-card-body {\n      padding: 20px 10px 0 10px;\n    }\n    .array-cards-addition {\n      box-shadow: none;\n      border: 1px solid #eee;\n      transition: all 0.35s ease-in-out;\n      &:hover {\n        border: 1px solid #ccc;\n      }\n    }\n    .empty-wrapper {\n      display: flex;\n      flex-direction: column;\n      align-items: center;\n      margin-bottom: 10px;\n      img {\n        height: 85px;\n      }\n      .ant-btn {\n        color: #888;\n      }\n    }\n  }\n  .card-list-empty.card-list-item.add-pointer {\n    cursor: pointer;\n  }\n\n  .array-cards-addition {\n    margin-top: 10px;\n    margin-bottom: 3px;\n    background: #fff;\n    display: flex;\n    cursor: pointer;\n    padding: 5px 0;\n    justify-content: center;\n    box-shadow: 1px 1px 4px 0 rgba(0, 0, 0, 0.1);\n  }\n  .card-list-item {\n    margin-top: 10px;\n    border: 1px solid #eee;\n  }\n  .card-list-item:first-child {\n    margin-top: 0 !important;\n  }\n  .ant-card-extra {\n    display: flex;\n    button {\n      margin-right: 8px;\n    }\n  }\n"], ["\n  width: 100%;\n  .ant-card {\n    .ant-card {\n      box-shadow: none;\n    }\n    .ant-card-body {\n      padding: 20px 10px 0 10px;\n    }\n    .array-cards-addition {\n      box-shadow: none;\n      border: 1px solid #eee;\n      transition: all 0.35s ease-in-out;\n      &:hover {\n        border: 1px solid #ccc;\n      }\n    }\n    .empty-wrapper {\n      display: flex;\n      flex-direction: column;\n      align-items: center;\n      margin-bottom: 10px;\n      img {\n        height: 85px;\n      }\n      .ant-btn {\n        color: #888;\n      }\n    }\n  }\n  .card-list-empty.card-list-item.add-pointer {\n    cursor: pointer;\n  }\n\n  .array-cards-addition {\n    margin-top: 10px;\n    margin-bottom: 3px;\n    background: #fff;\n    display: flex;\n    cursor: pointer;\n    padding: 5px 0;\n    justify-content: center;\n    box-shadow: 1px 1px 4px 0 rgba(0, 0, 0, 0.1);\n  }\n  .card-list-item {\n    margin-top: 10px;\n    border: 1px solid #eee;\n  }\n  .card-list-item:first-child {\n    margin-top: 0 !important;\n  }\n  .ant-card-extra {\n    display: flex;\n    button {\n      margin-right: 8px;\n    }\n  }\n"])));
ArrayCards.isFieldComponent = true;
export default ArrayCards;
var templateObject_1;
