var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { connect } from '@formily/react-schema-renderer';
import moment from 'moment';
import { DatePicker as AntdDatePicker } from 'antd';
import { mapStyledProps, mapTextComponent, compose, isStr, isArr } from '../shared';
var YearPicker = (function (_super) {
    __extends(YearPicker, _super);
    function YearPicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    YearPicker.prototype.render = function () {
        return React.createElement(AntdDatePicker, __assign({}, this.props, { picker: 'year' }));
    };
    return YearPicker;
}(React.Component));
var transformMoment = function (value, format) {
    if (format === void 0) { format = 'YYYY-MM-DD HH:mm:ss'; }
    if (value === '')
        return undefined;
    return value && value.format ? value.format(format) : value;
};
var mapMomentValue = function (props, fieldProps) {
    var value = props.value, _a = props.showTime, showTime = _a === void 0 ? false : _a, format = props.format;
    if (!fieldProps.editable)
        return props;
    try {
        if (isStr(value) && value) {
            props.value = moment(value, format || (showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'));
        }
        else if (isArr(value) && value.length) {
            props.value = value.map(function (item) {
                return (item &&
                    moment(item, format || (showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'))) ||
                    '';
            });
        }
    }
    catch (e) {
        throw new Error(e);
    }
    return props;
};
export var DatePicker = connect({
    getValueFromEvent: function (_, value) {
        var props = this.props || {};
        return transformMoment(value, props.format || (props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'));
    },
    getProps: compose(mapStyledProps, mapMomentValue),
    getComponent: mapTextComponent
})(AntdDatePicker);
DatePicker.RangePicker = connect({
    getValueFromEvent: function (_, _a) {
        var startDate = _a[0], endDate = _a[1];
        var props = this.props || {};
        var format = props.format || (props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD');
        return [
            transformMoment(startDate, format),
            transformMoment(endDate, format)
        ];
    },
    getProps: compose(mapStyledProps, mapMomentValue),
    getComponent: mapTextComponent
})(AntdDatePicker.RangePicker);
DatePicker.MonthPicker = connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value);
    },
    getProps: compose(mapStyledProps, mapMomentValue),
    getComponent: mapTextComponent
})(AntdDatePicker.MonthPicker);
DatePicker.WeekPicker = connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value, 'gggg-wo');
    },
    getProps: compose(mapStyledProps, function (props) {
        if (isStr(props.value) && props.value) {
            var parsed = props.value.match(/\D*(\d+)\D*(\d+)\D*/) || ['', '', ''];
            props.value = moment(parsed[1], 'YYYY').add(parsed[2] - 1, 'weeks');
        }
        return props;
    }),
    getComponent: mapTextComponent
})(AntdDatePicker.WeekPicker);
DatePicker.YearPicker = connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value, 'YYYY');
    },
    getProps: compose(mapStyledProps, mapMomentValue),
    getComponent: mapTextComponent
})(YearPicker);
export default DatePicker;
