import React from 'react';
import { IVirtualBoxProps } from '@formily/react-schema-renderer';
import { IFormStep } from '../types';
declare enum StateMap {
    ON_FORM_STEP_NEXT = "onFormStepNext",
    ON_FORM_STEP_PREVIOUS = "onFormStepPrevious",
    ON_FORM_STEP_GO_TO = "onFormStepGoto",
    ON_FORM_STEP_CURRENT_CHANGE = "onFormStepCurrentChange",
    ON_FORM_STEP_DATA_SOURCE_CHANGED = "onFormStepDataSourceChanged"
}
declare const EffectHooks: {
    onStepNext$: (...args: any[]) => import("rxjs/internal/Observable").Observable<void>;
    onStepPrevious$: (...args: any[]) => import("rxjs/internal/Observable").Observable<void>;
    onStepGoto$: (...args: any[]) => import("rxjs/internal/Observable").Observable<void>;
    onStepCurrentChange$: (...args: any[]) => import("rxjs/internal/Observable").Observable<{
        value: number;
        preValue: number;
    }>;
};
declare type ExtendsProps = StateMap & typeof EffectHooks;
export declare const FormStep: React.FC<IVirtualBoxProps<IFormStep>> & ExtendsProps;
export default FormStep;
