"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
    }
    else {
        cooked.raw = raw;
    }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var react_1 = __importStar(require("react"));
var react_schema_renderer_1 = require("@formily/react-schema-renderer");
var shared_1 = require("@formily/shared");
var react_shared_components_1 = require("@formily/react-shared-components");
var circle_button_1 = require("../circle-button");
var text_button_1 = require("../text-button");
var card_1 = __importDefault(require("antd/lib/card"));
var icons_1 = require("@ant-design/icons");
var styled_components_1 = __importDefault(require("styled-components"));
var classnames_1 = __importDefault(require("classnames"));
var ArrayComponents = {
    CircleButton: circle_button_1.CircleButton,
    TextButton: text_button_1.TextButton,
    AdditionIcon: function () { return react_1.default.createElement(icons_1.PlusOutlined, null); },
    RemoveIcon: function () { return react_1.default.createElement(icons_1.DeleteOutlined, null); },
    MoveDownIcon: function () { return react_1.default.createElement(icons_1.DownOutlined, null); },
    MoveUpIcon: function () { return react_1.default.createElement(icons_1.UpOutlined, null); }
};
exports.ArrayCards = styled_components_1.default(function (props) {
    var value = props.value, schema = props.schema, className = props.className, editable = props.editable, path = props.path, mutators = props.mutators;
    var _a = schema.getExtendsComponentProps() || {}, renderAddition = _a.renderAddition, renderRemove = _a.renderRemove, renderMoveDown = _a.renderMoveDown, renderMoveUp = _a.renderMoveUp, renderEmpty = _a.renderEmpty, renderExtraOperations = _a.renderExtraOperations, componentProps = __rest(_a, ["renderAddition", "renderRemove", "renderMoveDown", "renderMoveUp", "renderEmpty", "renderExtraOperations"]);
    var schemaItems = Array.isArray(schema.items)
        ? schema.items[schema.items.length - 1]
        : schema.items;
    var onAdd = function () {
        if (schemaItems) {
            mutators.push(schemaItems.getEmptyValue());
        }
    };
    return (react_1.default.createElement("div", { className: className }, react_1.default.createElement(react_shared_components_1.ArrayList, { value: value, minItems: schema.minItems, maxItems: schema.maxItems, editable: editable, components: ArrayComponents, renders: {
            renderAddition: renderAddition,
            renderRemove: renderRemove,
            renderMoveDown: renderMoveDown,
            renderMoveUp: renderMoveUp,
            renderEmpty: renderEmpty
        } }, shared_1.toArr(value).map(function (item, index) {
        return (react_1.default.createElement(card_1.default, __assign({}, componentProps, { size: "small", className: classnames_1.default("card-list-item", componentProps.className), key: index, title: react_1.default.createElement("span", null, index + 1, react_1.default.createElement("span", null, "."), " ", componentProps.title || schema.title), extra: react_1.default.createElement(react_1.Fragment, null, react_1.default.createElement(react_shared_components_1.ArrayList.Remove, { index: index, onClick: function () { return mutators.remove(index); } }), react_1.default.createElement(react_shared_components_1.ArrayList.MoveDown, { index: index, onClick: function () { return mutators.moveDown(index); } }), react_1.default.createElement(react_shared_components_1.ArrayList.MoveUp, { index: index, onClick: function () { return mutators.moveUp(index); } }), shared_1.isFn(renderExtraOperations)
                ? renderExtraOperations(index)
                : renderExtraOperations) }), schemaItems && (react_1.default.createElement(react_schema_renderer_1.SchemaField, { path: shared_1.FormPath.parse(path).concat(index), schema: schemaItems }))));
    }), react_1.default.createElement(react_shared_components_1.ArrayList.Empty, null, function (_a) {
        var children = _a.children, allowAddition = _a.allowAddition;
        return (react_1.default.createElement(card_1.default, __assign({}, componentProps, { size: "small", className: "card-list-item card-list-empty " + (allowAddition ? 'add-pointer' : ''), onClick: allowAddition ? onAdd : undefined }), react_1.default.createElement("div", { className: "empty-wrapper" }, children)));
    }), react_1.default.createElement(react_shared_components_1.ArrayList.Addition, null, function (_a) {
        var children = _a.children, isEmpty = _a.isEmpty;
        if (!isEmpty) {
            return (react_1.default.createElement("div", { className: "array-cards-addition", onClick: onAdd }, children));
        }
    }))));
})(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 100%;\n  .ant-card {\n    .ant-card {\n      box-shadow: none;\n    }\n    .ant-card-body {\n      padding: 20px 10px 0 10px;\n    }\n    .array-cards-addition {\n      box-shadow: none;\n      border: 1px solid #eee;\n      transition: all 0.35s ease-in-out;\n      &:hover {\n        border: 1px solid #ccc;\n      }\n    }\n    .empty-wrapper {\n      display: flex;\n      flex-direction: column;\n      align-items: center;\n      margin-bottom: 10px;\n      img {\n        height: 85px;\n      }\n      .ant-btn {\n        color: #888;\n      }\n    }\n  }\n  .card-list-empty.card-list-item.add-pointer {\n    cursor: pointer;\n  }\n\n  .array-cards-addition {\n    margin-top: 10px;\n    margin-bottom: 3px;\n    background: #fff;\n    display: flex;\n    cursor: pointer;\n    padding: 5px 0;\n    justify-content: center;\n    box-shadow: 1px 1px 4px 0 rgba(0, 0, 0, 0.1);\n  }\n  .card-list-item {\n    margin-top: 10px;\n    border: 1px solid #eee;\n  }\n  .card-list-item:first-child {\n    margin-top: 0 !important;\n  }\n  .ant-card-extra {\n    display: flex;\n    button {\n      margin-right: 8px;\n    }\n  }\n"], ["\n  width: 100%;\n  .ant-card {\n    .ant-card {\n      box-shadow: none;\n    }\n    .ant-card-body {\n      padding: 20px 10px 0 10px;\n    }\n    .array-cards-addition {\n      box-shadow: none;\n      border: 1px solid #eee;\n      transition: all 0.35s ease-in-out;\n      &:hover {\n        border: 1px solid #ccc;\n      }\n    }\n    .empty-wrapper {\n      display: flex;\n      flex-direction: column;\n      align-items: center;\n      margin-bottom: 10px;\n      img {\n        height: 85px;\n      }\n      .ant-btn {\n        color: #888;\n      }\n    }\n  }\n  .card-list-empty.card-list-item.add-pointer {\n    cursor: pointer;\n  }\n\n  .array-cards-addition {\n    margin-top: 10px;\n    margin-bottom: 3px;\n    background: #fff;\n    display: flex;\n    cursor: pointer;\n    padding: 5px 0;\n    justify-content: center;\n    box-shadow: 1px 1px 4px 0 rgba(0, 0, 0, 0.1);\n  }\n  .card-list-item {\n    margin-top: 10px;\n    border: 1px solid #eee;\n  }\n  .card-list-item:first-child {\n    margin-top: 0 !important;\n  }\n  .ant-card-extra {\n    display: flex;\n    button {\n      margin-right: 8px;\n    }\n  }\n"])));
exports.ArrayCards.isFieldComponent = true;
exports.default = exports.ArrayCards;
var templateObject_1;
