"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
    }
    else {
        cooked.raw = raw;
    }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var react_1 = __importStar(require("react"));
var react_schema_renderer_1 = require("@formily/react-schema-renderer");
var shared_1 = require("@formily/shared");
var react_shared_components_1 = require("@formily/react-shared-components");
var circle_button_1 = require("../circle-button");
var text_button_1 = require("../text-button");
var table_1 = __importDefault(require("antd/lib/table"));
var form_1 = __importDefault(require("antd/lib/form"));
var antd_1 = require("@formily/antd");
var icons_1 = require("@ant-design/icons");
var styled_components_1 = __importDefault(require("styled-components"));
var ArrayComponents = {
    CircleButton: circle_button_1.CircleButton,
    TextButton: text_button_1.TextButton,
    AdditionIcon: function () { return react_1.default.createElement(icons_1.PlusOutlined, { style: { fontSize: 20 } }); },
    RemoveIcon: function () { return react_1.default.createElement(icons_1.DeleteOutlined, null); },
    MoveDownIcon: function () { return react_1.default.createElement(icons_1.DownOutlined, null); },
    MoveUpIcon: function () { return react_1.default.createElement(icons_1.UpOutlined, null); }
};
var DragHandler = styled_components_1.default.span(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 7px;\n  display: inline-block;\n  height: 14px;\n  border: 2px dotted #c5c5c5;\n  border-top: 0;\n  border-bottom: 0;\n  cursor: move;\n  margin-bottom: 24px;\n"], ["\n  width: 7px;\n  display: inline-block;\n  height: 14px;\n  border: 2px dotted #c5c5c5;\n  border-top: 0;\n  border-bottom: 0;\n  cursor: move;\n  margin-bottom: 24px;\n"])));
exports.ArrayTable = styled_components_1.default(function (props) {
    var expressionScope = react_1.useContext(react_schema_renderer_1.FormExpressionScopeContext);
    var value = props.value, schema = props.schema, className = props.className, editable = props.editable, path = props.path, mutators = props.mutators;
    var _a = schema.getExtendsComponentProps() || {}, renderAddition = _a.renderAddition, renderRemove = _a.renderRemove, renderMoveDown = _a.renderMoveDown, renderMoveUp = _a.renderMoveUp, renderEmpty = _a.renderEmpty, renderExtraOperations = _a.renderExtraOperations, operationsWidth = _a.operationsWidth, operations = _a.operations, draggable = _a.draggable, componentProps = __rest(_a, ["renderAddition", "renderRemove", "renderMoveDown", "renderMoveUp", "renderEmpty", "renderExtraOperations", "operationsWidth", "operations", "draggable"]);
    var schemaItems = Array.isArray(schema.items)
        ? schema.items[schema.items.length - 1]
        : schema.items;
    var onAdd = function () {
        if (schemaItems) {
            mutators.push(schemaItems.getEmptyValue());
        }
    };
    var onMove = function (dragIndex, dropIndex) {
        mutators.move(dragIndex, dropIndex);
    };
    var renderColumns = function (items) {
        return items.mapProperties(function (props, key) {
            var itemProps = __assign(__assign({}, props.getExtendsItemProps()), props.getExtendsProps());
            return __assign(__assign({ title: react_schema_renderer_1.complieExpression(props.title, expressionScope) }, itemProps), { key: key, dataIndex: key, render: function (value, record, index) {
                    var newPath = shared_1.FormPath.parse(path).concat(index, key);
                    return (react_1.default.createElement(antd_1.FormItemShallowProvider, { key: newPath.toString(), label: undefined, labelCol: undefined, wrapperCol: undefined }, react_1.default.createElement(react_schema_renderer_1.SchemaField, { path: newPath, schema: props })));
                } });
        });
    };
    var columns = [];
    if (schema.items) {
        columns = shared_1.isArr(schema.items)
            ? schema.items.reduce(function (buf, items) {
                return buf.concat(renderColumns(items));
            }, [])
            : renderColumns(schema.items);
    }
    if (editable && operations !== false) {
        columns.push(__assign(__assign({}, operations), { key: 'operations', dataIndex: 'operations', width: operationsWidth || 200, render: function (value, record, index) {
                return (react_1.default.createElement(form_1.default.Item, null, react_1.default.createElement("div", { className: "array-item-operator" }, react_1.default.createElement(react_shared_components_1.ArrayList.Remove, { index: index, onClick: function () { return mutators.remove(index); } }), react_1.default.createElement(react_shared_components_1.ArrayList.MoveDown, { index: index, onClick: function () { return mutators.moveDown(index); } }), react_1.default.createElement(react_shared_components_1.ArrayList.MoveUp, { index: index, onClick: function () { return mutators.moveUp(index); } }), shared_1.isFn(renderExtraOperations)
                    ? renderExtraOperations(index)
                    : renderExtraOperations)));
            } }));
    }
    if (draggable) {
        columns.unshift({
            width: 20,
            key: 'dragHandler',
            render: function () {
                return react_1.default.createElement(DragHandler, { className: "drag-handler" });
            }
        });
    }
    var renderTable = function () {
        return (react_1.default.createElement(table_1.default, __assign({}, componentProps, { rowKey: function (record) {
                return shared_1.toArr(value).indexOf(record);
            }, pagination: false, columns: columns, dataSource: shared_1.toArr(value) })));
    };
    return (react_1.default.createElement("div", { className: className }, react_1.default.createElement(react_shared_components_1.ArrayList, { value: value, minItems: schema.minItems, maxItems: schema.maxItems, editable: editable, components: ArrayComponents, renders: {
            renderAddition: renderAddition,
            renderRemove: renderRemove,
            renderMoveDown: renderMoveDown,
            renderMoveUp: renderMoveUp,
            renderEmpty: renderEmpty
        } }, draggable ? (react_1.default.createElement(react_shared_components_1.DragListView, { onDragEnd: onMove, nodeSelector: "tr.ant-table-row", ignoreSelector: "tr.ant-table-expanded-row" }, renderTable())) : (renderTable()), react_1.default.createElement(react_shared_components_1.ArrayList.Addition, null, function (_a) {
        var children = _a.children;
        return (children && (react_1.default.createElement("div", { className: "array-table-addition", onClick: onAdd }, children)));
    }))));
})(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  width: 100%;\n  margin-bottom: 10px;\n  table {\n    margin-bottom: 0 !important;\n  }\n  .array-table-addition {\n    background: #fbfbfb;\n    cursor: pointer;\n    margin-top: 3px;\n    border-radius: 3px;\n    .next-btn-text {\n      color: #888;\n    }\n    .next-icon:before {\n      width: 16px !important;\n      font-size: 16px !important;\n      margin-right: 5px;\n    }\n  }\n  .ant-btn {\n    color: #888;\n  }\n  .array-item-operator {\n    display: flex;\n    button {\n      margin-right: 8px;\n    }\n  }\n"], ["\n  width: 100%;\n  margin-bottom: 10px;\n  table {\n    margin-bottom: 0 !important;\n  }\n  .array-table-addition {\n    background: #fbfbfb;\n    cursor: pointer;\n    margin-top: 3px;\n    border-radius: 3px;\n    .next-btn-text {\n      color: #888;\n    }\n    .next-icon:before {\n      width: 16px !important;\n      font-size: 16px !important;\n      margin-right: 5px;\n    }\n  }\n  .ant-btn {\n    color: #888;\n  }\n  .array-item-operator {\n    display: flex;\n    button {\n      margin-right: 8px;\n    }\n  }\n"])));
exports.ArrayTable.isFieldComponent = true;
exports.default = exports.ArrayTable;
var templateObject_1, templateObject_2;
