"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var react_1 = __importDefault(require("react"));
var react_schema_renderer_1 = require("@formily/react-schema-renderer");
var moment_1 = __importDefault(require("moment"));
var date_picker_1 = __importDefault(require("antd/lib/date-picker"));
var shared_1 = require("../shared");
var YearPicker = (function (_super) {
    __extends(YearPicker, _super);
    function YearPicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    YearPicker.prototype.render = function () {
        return react_1.default.createElement(date_picker_1.default, __assign({}, this.props, { picker: 'year' }));
    };
    return YearPicker;
}(react_1.default.Component));
var transformMoment = function (value, format) {
    if (format === void 0) {
        format = 'YYYY-MM-DD HH:mm:ss';
    }
    if (value === '')
        return undefined;
    return value && value.format ? value.format(format) : value;
};
var mapMomentValue = function (props, fieldProps) {
    var value = props.value, _a = props.showTime, showTime = _a === void 0 ? false : _a, format = props.format;
    if (!fieldProps.editable)
        return props;
    try {
        if (shared_1.isStr(value) && value) {
            props.value = moment_1.default(value, format || (showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'));
        }
        else if (shared_1.isArr(value) && value.length) {
            props.value = value.map(function (item) {
                return (item &&
                    moment_1.default(item, format || (showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'))) ||
                    '';
            });
        }
    }
    catch (e) {
        throw new Error(e);
    }
    return props;
};
exports.DatePicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, value) {
        var props = this.props || {};
        return transformMoment(value, props.format || (props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD'));
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, mapMomentValue),
    getComponent: shared_1.mapTextComponent
})(date_picker_1.default);
exports.DatePicker.RangePicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, _a) {
        var startDate = _a[0], endDate = _a[1];
        var props = this.props || {};
        var format = props.format || (props.showTime ? 'YYYY-MM-DD HH:mm:ss' : 'YYYY-MM-DD');
        return [
            transformMoment(startDate, format),
            transformMoment(endDate, format)
        ];
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, mapMomentValue),
    getComponent: shared_1.mapTextComponent
})(date_picker_1.default.RangePicker);
exports.DatePicker.MonthPicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value);
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, mapMomentValue),
    getComponent: shared_1.mapTextComponent
})(date_picker_1.default.MonthPicker);
exports.DatePicker.WeekPicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value, 'gggg-wo');
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, function (props) {
        if (shared_1.isStr(props.value) && props.value) {
            var parsed = props.value.match(/\D*(\d+)\D*(\d+)\D*/) || ['', '', ''];
            props.value = moment_1.default(parsed[1], 'YYYY').add(parsed[2] - 1, 'weeks');
        }
        return props;
    }),
    getComponent: shared_1.mapTextComponent
})(date_picker_1.default.WeekPicker);
exports.DatePicker.YearPicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value, 'YYYY');
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, mapMomentValue),
    getComponent: shared_1.mapTextComponent
})(YearPicker);
exports.default = exports.DatePicker;
