"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var react_1 = __importStar(require("react"));
var antd_1 = require("@formily/antd");
var react_schema_renderer_1 = require("@formily/react-schema-renderer");
var shared_1 = require("@formily/shared");
var row_1 = __importDefault(require("antd/lib/row"));
var col_1 = __importDefault(require("antd/lib/col"));
var shared_2 = require("../shared");
exports.FormItemGrid = react_schema_renderer_1.createVirtualBox('grid', function (props) {
    var rawCols = props.cols, title = props.title, label = props.label;
    var formItemProps = antd_1.pickFormItemProps(props);
    var gridProps = antd_1.pickNotFormItemProps(props);
    var children = shared_1.toArr(props.children);
    var cols = shared_1.toArr(rawCols).map(function (col) { return shared_2.normalizeCol(col); });
    var childNum = children.length;
    if (cols.length < childNum) {
        var offset = childNum - cols.length;
        var lastSpan = 24 -
            cols.reduce(function (buf, col) {
                return (buf +
                    Number(col.span ? col.span : 0) +
                    Number(col.offset ? col.offset : 0));
            }, 0);
        for (var i = 0; i < offset; i++) {
            cols.push({ span: Math.floor(lastSpan / offset) });
        }
    }
    var grids = (react_1.default.createElement(row_1.default, __assign({}, gridProps), children.reduce(function (buf, child, key) {
        return child
            ? buf.concat(react_1.default.createElement(col_1.default, __assign({ key: key }, cols[key]), child))
            : buf;
    }, [])));
    if (title || label) {
        return (react_1.default.createElement(antd_1.AntdSchemaFieldAdaptor, __assign({}, formItemProps), grids));
    }
    return react_1.default.createElement(react_1.Fragment, null, grids);
});
exports.default = exports.FormItemGrid;
