"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", { value: raw });
    }
    else {
        cooked.raw = raw;
    }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s)
                if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s)
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++)
        s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var react_1 = __importDefault(require("react"));
var antd_1 = require("@formily/antd");
exports.mapTextComponent = antd_1.mapTextComponent;
exports.mapStyledProps = antd_1.mapStyledProps;
exports.normalizeCol = antd_1.normalizeCol;
var select_1 = __importDefault(require("antd/lib/select"));
var styled_components_1 = __importDefault(require("styled-components"));
var shared_1 = require("@formily/shared");
__export(require("@formily/shared"));
exports.compose = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return function (payload) {
        var extra = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            extra[_i - 1] = arguments[_i];
        }
        return args.reduce(function (buf, fn) {
            return buf !== undefined ? fn.apply(void 0, __spreadArrays([buf], extra)) : fn.apply(void 0, __spreadArrays([payload], extra));
        }, payload);
    };
};
var createEnum = function (enums) {
    if (shared_1.isArr(enums)) {
        return enums.map(function (item) {
            if (typeof item === 'object') {
                return __assign({}, item);
            }
            else {
                return {
                    label: item,
                    value: item
                };
            }
        });
    }
    return [];
};
exports.Select = styled_components_1.default(function (props) {
    var _a = props.dataSource, dataSource = _a === void 0 ? [] : _a, onChange = props.onChange, others = __rest(props, ["dataSource", "onChange"]);
    var children = createEnum(dataSource).map(function (item) {
        var label = item.label, value = item.value, others = __rest(item, ["label", "value"]);
        return (react_1.default.createElement(select_1.default.Option, __assign({ key: value }, others, { title: label, value: value }), label));
    });
    return (react_1.default.createElement(select_1.default, __assign({ className: props.className }, others, { onChange: function (value, options) {
            onChange(value, shared_1.isArr(options)
                ? options.map(function (item) { return (__assign(__assign({}, item), { props: undefined })); })
                : __assign(__assign({}, options), { props: undefined }));
        } }), children));
})(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  min-width: 100px;\n  width: 100%;\n"], ["\n  min-width: 100px;\n  width: 100%;\n"])));
exports.acceptEnum = function (component) {
    return function (_a) {
        var dataSource = _a.dataSource, others = __rest(_a, ["dataSource"]);
        if (dataSource) {
            return react_1.default.createElement(exports.Select, __assign({ dataSource: dataSource }, others));
        }
        else {
            return react_1.default.createElement(component, others);
        }
    };
};
exports.transformDataSourceKey = function (component, dataSourceKey) {
    return function (_a) {
        var _b;
        var dataSource = _a.dataSource, others = __rest(_a, ["dataSource"]);
        return react_1.default.createElement(component, __assign((_b = {}, _b[dataSourceKey] = dataSource, _b), others));
    };
};
exports.createMatchUpdate = function (name, path) {
    return function (targetName, targetPath, callback) {
        if (targetName || targetPath) {
            if (targetName) {
                if (shared_1.FormPath.parse(targetName).matchAliasGroup(name, path)) {
                    callback();
                }
            }
            else if (targetPath) {
                if (shared_1.FormPath.parse(targetPath).matchAliasGroup(name, path)) {
                    callback();
                }
            }
        }
        else {
            callback();
        }
    };
};
var templateObject_1;
