"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_schema_renderer_1 = require("@formily/react-schema-renderer");
var moment_1 = __importDefault(require("moment"));
var time_picker_1 = __importDefault(require("antd/lib/time-picker"));
var shared_1 = require("../shared");
var transformMoment = function (value) {
    if (value === '')
        return undefined;
    return value;
};
var mapMomentValue = function (props, fieldProps) {
    var value = props.value, _a = props.format, format = _a === void 0 ? 'HH:mm:ss' : _a;
    if (!fieldProps.editable)
        return props;
    try {
        if (shared_1.isStr(value) && value) {
            props.value = moment_1.default(value, format);
        }
        else if (shared_1.isArr(value) && value.length) {
            props.value = value.map(function (item) { return (item && moment_1.default(item, format)) || ''; });
        }
    }
    catch (e) {
        throw new Error(e);
    }
    return props;
};
exports.TimePicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, value) {
        return transformMoment(value);
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, mapMomentValue),
    getComponent: shared_1.mapTextComponent,
})(time_picker_1.default);
exports.TimePicker.RangePicker = react_schema_renderer_1.connect({
    getValueFromEvent: function (_, _a) {
        var startDate = _a[0], endDate = _a[1];
        return [transformMoment(startDate), transformMoment(endDate)];
    },
    getProps: shared_1.compose(shared_1.mapStyledProps, mapMomentValue),
    getComponent: shared_1.mapTextComponent,
})(time_picker_1.default.RangePicker);
exports.default = exports.TimePicker;
